

// ------------------------------------------------------------------
//              EEPROM- Variablen 	  
// ------------------------------------------------------------------
#include "C:\UT20\UT-EEPRO.c";


extern char cTaste, cBarMrk, cBarLen, cBarBuffer[];

extern char cBLANK20[];
extern void Delay(unsigned int time);

void PrintOkAbbruch (void);


// -------------------------------------------------------------------
//  Tastatureingabe
// -------------------------------------------------------------------
char Eingabe (unsigned int x_y, char *buf, unsigned int len_size )
{
char z, cStart = 0;
unsigned int Ein_pos, Ein_cpos;

#define x	  (char) (x_y >> 8)
#define y	  (char) (x_y & 0xFF)
#define len  (char) (len_size >> 8)
#define size (char) (len_size & 0xFF)

	if ( len == 0 )
		return (T_ENT);

						//	  	 123456789a123456789b123456789c123456789d
L0: //xPutS ((0<<8) | 7, "<ESC>=Eing.abbrechen          <ENTER>=OK", (0<<8) | 1);
	  PrintOkAbbruch();
 	  xPutS (x_y, buf, len_size);

    if (size == 1)
        { GrCont(CURSOR_ON);
          GrData(x+len-1); GrData (y); GrCont(CURSADDR);
        }

    else if (size == 2)
        {
        Ein_pos  =  (x + len-1)*2;        // da doppelte Groesse
        Ein_pos += (char) y * 40 * 16;  // 40 Byte/Zeile, 16 Grafikzeilen
        Ein_pos +=  14 * 40;

        Ein_cpos = Ein_pos; // Cursorposition merken, spart spaeter die Rechnerei

        z=2;
        do  {                                   // Cursor 'malen'
            GrSetA (Ein_pos);
            GrData(0xFF ); GrCont ( WRT );      // MSB
            GrData(0xFF ); GrCont ( WRT );      // LSB
            Ein_pos += 40;                      // naechste Grafikzeile
            } while (--z);
        }//EndOfSize=2

    ResetBarcode();
    while (1)
        {
        (void) DKS();
        if (cTaste )
            break;      // Der Bediener hat sich fuer die Tasten entschieden

			if (cBarMrk)    // In der DFS wurde ein Barcode erkannt.
				{
				// 17.10.02
				// -------- 
				// Wenn eRedBarcode = True ist, und...
				//	- das erste Zeichen = 2 ist, dann nur das erste Zeichen lschen,
				// - das erste Zeichen = 1 ist, dann die ersten 3 Zeichen lschen !
				// Grund, die 1+2 wurden beim 2450/80 als Steuerzeichen benutzt.
				//
				if ( eRedBarcode == '1' )
					{
					if (*cBarBuffer == '1' || *cBarBuffer == '2')
						{  
						if (*cBarBuffer == '1')	z = 3;
						else							z = 1;
						memcpy (cBarBuffer, &cBarBuffer[z], strlen (cBarBuffer));
						cBarLen -= z;
						}
				 	}
		
				// 28.01.03
				// Muss die Laenge des Barcode genau sein ?
				if	( eRedBarcode & 0x04 )
					{
					if (len != cBarLen)
						{
						cBarMrk = 0;
					  	xPutS( x_y, "FALSCH", 2);
						Delay (1000);
						xPutS( x_y, cBLANK20, (20<<8) | 2);
						goto L0; 
						}
					}
				memset ( buf, ' ', len);
         	if (cBarLen > len)	 					// 20.10.00	ShiftLeft des Barcodes vermeiden !
					cBarLen = len;

				memcpy ( &buf[len-cBarLen], cBarBuffer, cBarLen);
          	xPutS (x_y, buf, len_size);        					// Barcode anzeigen
           Delay (500);                        					// 500ms warten
           ResetBarcode();                     					// Barcodesp. loeschen
           return( T_ENT );                    					// und mit ENTER quittieren.
           }
        }//EndOfWhile(1)

    do
    {
    while ( !cTaste )
        DKS();

    if (cTaste == T_ENT || cTaste == T_ESC)
        break; 

    else if (cTaste == T_CLR)
        {
        cStart = 1;
        for (z=len-1; z != 0; z--)
            *(buf+z) = *(buf-1+z);
        *buf = ' ';
        }

    else if(cTaste < 0x80)
        {
        if ( !cStart )
            {
            cStart = 1;
            memset (buf, ' ', len);
            }
        for(z=0; z < len-1; z++)
            *(buf+z) = *(buf+1+z);
        *(buf+z) = cTaste;
        }

    //xPutS ((x<<8) | y, buf, (len<<8) | size);
	  xPutS (x_y, buf, len_size);
    cTaste = 0;

    }while(1);

    if (size == 2)
        {
        for (z=0; z < 2; z++)                   // gemalten Cursor 'loeschen'
            {
            GrSetA(Ein_cpos);                   // Adresse vom Curs.ausgeben
            GrData( 0 ); GrCont ( WRT );        // MSB
            GrData( 0 ); GrCont ( WRT );        // LSB
            Ein_cpos += 40;                     // naechste Grafikzeile
            }
        }
    GrCont(CURSOR_OFF);
    z = cTaste;
    cTaste = 0;
    return (z);

#undef x
#undef y
#undef size
#undef len 
}

